//+------------------------------------------------------------------+
//|                                                     cust_ind.mq4 |
//|                                          Copyright Shaun Overton |
//|                                           www.onestepremoved.com |
//+------------------------------------------------------------------+
#property copyright "Copyright OneStepRemoved.com, Inc."
#property link      "www.onestepremoved.com"


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
#import "Scanner.dll"
string currpharser(string);
bool IsChecked(string);
bool ValidatePeriods();
//buffers used for drawing 
double ExtMapBuffer[];
double ExtMapBuffer2[];
//buffer used for calcs
double CurrentBuffer[89679];
double ImaginaryBufferS[89679];
double ImaginaryBufferF[89679];
//----
int ExtCountedBars=0;
//currenct Security 
string Currency;
//
int THIS_BAR=0;
int LAST_BAR=1;
datetime LastChecked=NULL;
//current Security Periods to check
int Periods[30][9];
datetime CheckTimes [30][9];
//Type of MA

//MA Settings fast
extern int MAFast_Period=1;
extern int MAFast_Shift=0;
extern int MAFast_Method=0;

//MA settings slow
extern int MASlow_Period=2;
extern int MASlow_Shift=0;
extern int MASlow_Method=0;

//Currency settings 
//use comma to seperate
extern string Currency_1="EURUSD,D1"; 
extern string Currency_2=""; 
extern string Currency_3=""; 
extern string Currency_4=""; 
extern string Currency_5="";
extern string Currency_6=""; 
extern string Currency_7=""; 
extern string Currency_8=""; 
extern string Currency_9=""; 
extern string Currency_10=""; 
extern string Currency_11=""; 
extern string Currency_12=""; 
extern string Currency_13=""; 
extern string Currency_14=""; 
extern string Currency_15="";
extern string Currency_16=""; 
extern string Currency_17=""; 
extern string Currency_18=""; 
extern string Currency_19=""; 
extern string Currency_20=""; 
extern string Currency_21=""; 
extern string Currency_22=""; 
extern string Currency_23=""; 
extern string Currency_24=""; 
extern string Currency_25="";
extern string Currency_26=""; 
extern string Currency_27=""; 
extern string Currency_28=""; 
extern string Currency_29=""; 
extern string Currency_30="";  
string CurrencyArray[30];
string LOGO;

int init()
  {
   Currency="";
  for(int W=0;W<9;W++)
   ExtCountedBars=0;
   int    draw_begin,draw_begin2;
   string short_name;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexShift(0,MASlow_Shift);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexShift(1,MAFast_Shift);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(MASlow_Period<2) MASlow_Period=13;
   draw_begin=MASlow_Period-1;
   if(MAFast_Period<2) MAFast_Period=13;
   draw_begin2=MAFast_Period-1;
//---- indicator short name
   switch(MASlow_Method)
     {
      case 1 : short_name="EMA Slow()";  draw_begin=0;  break;
      case 2 : short_name="SMMA Slow ()"; break;
      case 3 : short_name="LWMA Slow()"; break;
      default :
         MASlow_Method=0;
         short_name="SMA Slow()";
     }
      switch(MAFast_Method)
     {
      case 1 : short_name=StringConcatenate( short_name,"EMA Fast(");  draw_begin2=0;  break;
      case 2 : short_name=StringConcatenate( short_name,"SMMA Fast("); break;
      case 3 : short_name=StringConcatenate( short_name,"LWMA Fast("); break;
      default :
         MAFast_Method=0;
         short_name=StringConcatenate(short_name,"SMA Fast(");
     }
   IndicatorShortName(short_name+")");
   SetIndexDrawBegin(0,draw_begin);
   SetIndexDrawBegin(1,draw_begin2);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);
   SetIndexBuffer(1,ExtMapBuffer2);
//setting Currency Array
CurrencyArray[0]=Currency_1; CurrencyArray[15]=Currency_16;
CurrencyArray[1]=Currency_2; CurrencyArray[16]=Currency_17;
CurrencyArray[2]=Currency_3; CurrencyArray[17]=Currency_18;
CurrencyArray[3]=Currency_4; CurrencyArray[18]=Currency_19;
CurrencyArray[4]=Currency_5; CurrencyArray[19]=Currency_20;
CurrencyArray[5]=Currency_6; CurrencyArray[20]=Currency_21;
CurrencyArray[6]=Currency_7; CurrencyArray[21]=Currency_22;
CurrencyArray[7]=Currency_8; CurrencyArray[22]=Currency_23;
CurrencyArray[8]=Currency_9; CurrencyArray[23]=Currency_24;
CurrencyArray[9]=Currency_10; CurrencyArray[24]=Currency_25;
CurrencyArray[10]=Currency_11; CurrencyArray[25]=Currency_26;
CurrencyArray[11]=Currency_12; CurrencyArray[26]=Currency_27;
CurrencyArray[12]=Currency_13; CurrencyArray[27]=Currency_28;
CurrencyArray[13]=Currency_14; CurrencyArray[28]=Currency_29;
CurrencyArray[14]=Currency_15; CurrencyArray[29]=Currency_30;
//parsing string array
for(int U=0;U<30;U++)
{
  if(CurrencyArray[U]!="")
   {
      string tmp=CurrencyArray[U];
     //pharse externs
     CurrencyArray[U]=currpharser(tmp);
    //checking for valad currency
   if(MarketInfo( CurrencyArray[U],MODE_BID)==0||ValidatePeriods())
      {
      Alert("Invalad Currency or Input Check#"+U+1);
      return(0);
      }
   //setting bool matrix
   if(IsChecked("M1"))
      Periods[U][0]=PERIOD_M1;
   else
      Periods[U][0]=0;
   if(IsChecked("M5"))
      Periods[U][1]=PERIOD_M5;
   else
      Periods[U][1]=0;
   if(IsChecked("M15"))
      Periods[U][2]=PERIOD_M15;
   else
      Periods[U][2]=0;
   if(IsChecked("M30"))
      Periods[U][3]=PERIOD_M30;   
    else
      Periods[U][3]=0;
   if(IsChecked("H1"))
      Periods[U][4]=PERIOD_H1;  
   else
      Periods[U][4]=0;
   if(IsChecked("H4"))
      Periods[U][5]=PERIOD_H4; 
   else
      Periods[U][5]=0; 
   if(IsChecked("D1"))
      Periods[U][6]=PERIOD_D1;
   else
      Periods[U][7]=0;
   if(IsChecked("W1"))
      Periods[U][7]=PERIOD_W1;  
    else
      Periods[U][7]=0; 
   if(IsChecked("MN1"))
      Periods[U][8]=PERIOD_MN1;  
    else
      Periods[U][8]=0;
   }

}
  //inti time matrix
   for(U=0;U<30;U++)
     for(int M=0;M<9;M++)
       CheckTimes[U][M]=NULL;
//---- initialization done
LOGO="LOGO";
ObjectCreate(LOGO, OBJ_LABEL,0,0,0) ;
ObjectSet(LOGO, OBJPROP_CORNER, 2);    // Reference corner
ObjectSet(LOGO, OBJPROP_XDISTANCE, 10);// X coordinate
ObjectSet(LOGO, OBJPROP_YDISTANCE, 15);// Y coordinate
ObjectSetText(LOGO, "Market Scanner - OneStepRemoved.com", 14, "Arial", Red);
   return(0);
  }
  int deinit() 
  {
  ObjectDelete( LOGO) ;
  return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   if(Bars<=MAFast_Period) return(0);
   if(Bars<=MASlow_Period) return(0);
//Imaginary MA section 
for(int P=0;P<30;P++)
{
//checking for empty arrays
 if(CurrencyArray[P]!="")
   {
  //Generate Imaginary MAs 
  for(int M=0;M<9;M++)
      {  
      //checking time stamp 
       if(CheckTimes[P][M]!=iTime(CurrencyArray[P],Periods[P][M],THIS_BAR))
       {
      //checking for time period to draw
      if(Periods[P][M]!=0)
         {
         // setting bar count ibar returns 0 randomly?
          int SecBars=iBars(CurrencyArray[P],Periods[P][M]);
          while(SecBars==0)
            SecBars=iBars(CurrencyArray[P],Periods[P][M]);
        
          //calc imaginary ma
         switch(MASlow_Method)
               {
                  case 0 : sma(CurrencyArray[P],MASlow_Period,Periods[P][M],SecBars,SecBars-3,0);  break;
                  case 1 : ema(CurrencyArray[P],MASlow_Period,Periods[P][M],SecBars,SecBars-3,0);  break;
                  case 2 : smma(CurrencyArray[P],MASlow_Period,Periods[P][M],SecBars,SecBars-3,0); break;
                  case 3 : lwma(CurrencyArray[P],MASlow_Period,Periods[P][M],SecBars,SecBars-3,0);
               }
         //copy array data for comparsion
         ArrayCopy(ImaginaryBufferS,CurrentBuffer,0,0,SecBars); 
          switch(MAFast_Method)
               {
                  case 0 : sma(CurrencyArray[P],MAFast_Period,Periods[P][M],SecBars,SecBars-3,0);  break;
                  case 1 : ema(CurrencyArray[P],MAFast_Period,Periods[P][M],SecBars,SecBars-3,0);  break;
                  case 2 : smma(CurrencyArray[P],MAFast_Period,Periods[P][M],SecBars,SecBars-3,0); break;
                  case 3 : lwma(CurrencyArray[P],MAFast_Period,Periods[P][M],SecBars,SecBars-3,0); 
               }
           
           //compare Imaginary Buffers
           for(int Q=0;Q<=THIS_BAR;Q++)
               {
                  if(ImaginaryBufferS[Q]>=CurrentBuffer[Q]&&ImaginaryBufferS[Q+1]<CurrentBuffer[Q+1])
                     Alert("Fast MA crossed DOWN: "+CurrencyArray[P]+"; MA Value:"+DoubleToStr(CurrentBuffer[Q],MarketInfo(CurrencyArray[P],MODE_DIGITS))+" At TIME:"+
                     TimeToStr(iTime(CurrencyArray[P],Periods[P][M],Q),TIME_DATE|TIME_MINUTES)+" in Period: "+StringPeriod(Periods[P][M]));
                  else if(ImaginaryBufferS[Q]<=CurrentBuffer[Q]&&ImaginaryBufferS[Q+1]>CurrentBuffer[Q+1])
                     Alert("Fast MA crossed UP: "+CurrencyArray[P]+" MA Value:"+DoubleToStr(CurrentBuffer[Q],MarketInfo(CurrencyArray[P],MODE_DIGITS))+" At TIME:"+
                     TimeToStr(iTime(CurrencyArray[P],Periods[P][M],Q),TIME_DATE|TIME_MINUTES)+" in Period: "+StringPeriod(Periods[P][M]));
               } 
          CheckTimes[P][M]=iTime(CurrencyArray[P],Periods[P][M],THIS_BAR);
          ExtCountedBars=SecBars-Period()/Periods[P][M];
          }
        }
    }
   }
}
//---- done
   return(0);
  }

//+------------------------------------------------------------------+
//| Simple Moving Average                                            |
//+------------------------------------------------------------------+
void sma(string Sec,int MAtime,int Graphtime, int PeriodBars,int CountedBars,int draw)
  {
   double sum=0;
   int    i,pos=PeriodBars-CountedBars-1;
//---- initial accumulation
   if(pos<MAtime) pos=MAtime;
   for(i=1;i<MAtime;i++,pos--)
      sum+=iClose(Sec,Graphtime,pos);
     
//---- main calculation loop
   while(pos>=0)
     {
      sum+=iClose(Sec,Graphtime,pos);
      CurrentBuffer[pos]=sum/MAtime;
      if(draw==1)
           ExtMapBuffer[pos]=sum/MAtime;
       else if(draw==2)
           ExtMapBuffer2[pos]=sum/MAtime;
	   sum-=iClose(Sec,Graphtime,(pos+MAtime-1));
 	   pos--;
     }
//---- zero initial bars
   if(CountedBars<1)
      for(i=1;i<MAtime;i++) 
      {
      CurrentBuffer[PeriodBars-i]=0;
       if(draw==1)
           ExtMapBuffer[PeriodBars-i]=0;
       else if(draw==0)
          ExtMapBuffer2[PeriodBars-i]=0;
      }
  }
  
//+------------------------------------------------------------------+
//| Exponential Moving Average                                       |
//+------------------------------------------------------------------+
void ema(string Sec,int MAtime,int Graphtime,int PeriodBars,int CountedBars,int draw)
  {
   double pr=2.0/(MAtime+1);
   int    pos=PeriodBars-2;
   if(CountedBars>2) pos=PeriodBars-CountedBars-1;
//---- main calculation loop
   while(pos>=0)
     {
      if(pos==PeriodBars-2) 
      CurrentBuffer[pos+1]=iClose(Sec,Graphtime,pos);
      CurrentBuffer[pos]=iClose(Sec,Graphtime,pos)*pr+CurrentBuffer[pos+1]*(1-pr);
      if(draw==1)
         {
         if(pos==PeriodBars-2) 
         ExtMapBuffer[pos+1]=iClose(Sec,Graphtime,pos);
         ExtMapBuffer[pos]=iClose(Sec,Graphtime,pos)*pr+ExtMapBuffer[pos+1]*(1-pr);
         }
      else if(draw==2)
        {
        if(pos==PeriodBars-2) 
         ExtMapBuffer2[pos+1]=iClose(Sec,Graphtime,pos);
         ExtMapBuffer2[pos]=iClose(Sec,Graphtime,pos)*pr+ExtMapBuffer2[pos+1]*(1-pr);
         }
 	   pos--;
     }
  }
  
//+------------------------------------------------------------------+
//| Smoothed Moving Average                                          |
//+------------------------------------------------------------------+
void smma(string Sec,int MAtime,int Graphtime,int PeriodBars,int CountedBars,int draw)
  {
   double sum=0;
   int    i,k,pos=PeriodBars-CountedBars+1;
//---- main calculation loop
   pos=PeriodBars-MAtime;
   if(pos>PeriodBars-CountedBars) pos=PeriodBars-CountedBars;
   while(pos>=0)
     {
      if(pos==PeriodBars-MAtime)
        {
         //---- initial accumulation
         for(i=0,k=pos;i<MAtime;i++,k++)
           {
            sum+=iClose(Sec,Graphtime,k);
            //---- zero initial bars
            CurrentBuffer[k]=0;
           if(draw==1)
             ExtMapBuffer[k]=0;
           else if(draw==2)
             ExtMapBuffer2[k]=0;
           }
        }
      else 
         {
         sum=CurrentBuffer[pos+1]*(MAtime-1)+iClose(Sec,Graphtime,pos);
         if(draw==1)
            sum=ExtMapBuffer[pos+1]*(MAtime-1)+iClose(Sec,Graphtime,pos);
         else if(draw==2)
            sum=ExtMapBuffer2[pos+1]*(MAtime-1)+iClose(Sec,Graphtime,pos);
         }
      if(draw==1)  
         ExtMapBuffer[pos]=sum/MAtime;
      else if(draw==2)
         ExtMapBuffer2[pos]=sum/MAtime;
      CurrentBuffer[pos]=sum/MAtime;
 	   pos--;
     }
  }
 
//+------------------------------------------------------------------+
//| Linear Weighted Moving Average                                   |
//+------------------------------------------------------------------+
void lwma(string Sec,int MAtime,int Graphtime,int PeriodBars,int CountedBars,int draw)
  {
   double sum=0.0,lsum=0.0;
   double price;
   int    i,weight=0,pos=PeriodBars-CountedBars-1;
//---- initial accumulation
   if(pos<MAtime) pos=MAtime;
   for(i=1;i<=MAtime;i++,pos--)
     {
      price=iClose(Sec,Graphtime,pos);
      sum+=price*i;
      lsum+=price;
      weight+=i;
     }
//---- main calculation loop
   pos++;
   i=pos+MAtime;
   while(pos>=0)
     {
     if(draw==1)
      ExtMapBuffer[pos]=sum/weight;
     else if(draw==2)
      ExtMapBuffer2[pos]=sum/weight;
     CurrentBuffer[pos]=sum/weight;
      if(pos==0) break;
      pos--;
      i--;
      price=iClose(Sec,Graphtime,pos);
      sum=sum-lsum+price*MAtime;
      lsum-=iClose(Sec,Graphtime,i);
      lsum+=price;
     }
//---- zero initial bars
   if(CountedBars<1)
      for(i=1;i<MAtime;i++) 
         {
         CurrentBuffer[PeriodBars-i]=0;
         if(draw==1)
          ExtMapBuffer[PeriodBars-i]=0;
         else if(draw==2)
           ExtMapBuffer2[PeriodBars-i]=0;  
         }
  }
 
//+------------------------------------------------------------------+
//| Alert Message                                   |
//+------------------------------------------------------------------+

string StringPeriod(double P)
   { 
   string Chart_Period="";
   switch((int)P)
      {
      case 1: Chart_Period="M1"; break;
      case 5: Chart_Period="M5"; break;
      case 15: Chart_Period="M15"; break;
      case 30: Chart_Period="M30"; break;
      case 60: Chart_Period="H1"; break;
      case 240: Chart_Period="H4"; break;
      case 1440: Chart_Period="D1"; break;
      case 10080: Chart_Period="W1"; break;
      case 43200: Chart_Period="MN1"; break;
      default: Chart_Period=DoubleToStr(P,0);
      }
     return (Chart_Period);
   }
   